//
// Created by robtor on 06.01.23.
//

#ifndef FLOATPUMP_MENU_ENTRY_TYPE_READONLY_H
#define FLOATPUMP_MENU_ENTRY_TYPE_READONLY_H

#include "Menu_Entry_Type_Delegate.h"

namespace floatpump {
    namespace menu {

        template <class T>
        class Menu_Entry_Type_ReadOnly : public Menu_Entry_Type_Delegate {
        public:
            explicit Menu_Entry_Type_ReadOnly(T store) {
                m_store = new T(store);
            };

            std::string toString() override {
                return std::to_string(*m_store);
            }

            void u_press() override {

            }

            void u_increase(uint16_t steps) override {

            }

            void u_decrease(uint16_t steps) override {

            }

            bool isEntered() override {
                return false;
            }

            void linkConfig(T *link) {
                m_store = link;
            }

        private:
            T *m_store;
        };

    } // floatpump
} // menu

#endif //FLOATPUMP_MENU_ENTRY_TYPE_READONLY_H
